#ifndef _PARSER_H_
#   define _PARSER_H_

#include <string>
#include <vector>

using std::string;
using std::vector;

#define PARSER_SHIFT      "s"
#define PARSER_REPEAT     "r"
#define PARSER_SILENCE    "x"
#define PARSER_VOLUME     "v"
#define PARSER_INSTRUMENT "i"

// ---------------------
// class Event
// ---------------------

class Midi;

class Event
{
   public:
      virtual string toString()   = 0;
      virtual void apply(Midi *m) = 0;
};

typedef vector<Event *> EventPtrVector;

// ---------------------
// class Parser
// ---------------------

class Parser
{
   public:
      static bool getArgs(
         int    argc,
         char   **argv,
         int    *defaultVolumePtr,
         int    *defaultInstrumentPtr,
         string &fileName,
         string &errMsg
      );

      static bool fileToString(
         const string &fileName, string &contents, string &errMsg
      );

      static bool getEvents(
         const          string &contents,
         int            defaultVolume,
         int            defaultInstrument,
         EventPtrVector &events,
         int            &timeOffset,
         string         &errMsg
      );
};

#endif
